*+
*+
*+    Source Module => H:\DLOADS\FTP\TEMP\TEMP\ROUNDING.PRG
*+
*+    Contents: Function t()
*+              Function ROUNDING()
*+
*+    Reformatted by Click! on May-7-1997 at 11:25 pm
*+
*+

/*
The internal clipper round() function, sometimes gives an incorrect
lower value. Str() or transform() also does but with other values.
*/

#ifdef TEST
*+
*+
*+    Function t()
*+
*+
*+
func t
local n

n := 1.275
? round( n, 2 )              // :-( error: 1.27
? str( n, 10, 2 )            // :-) 1.28
? transf( n, "####.##" )     // :-) 1.28
? rounding( n, 2 )           // :-) 1.28  my routine: see below

n := 8.235
? round( n, 2 )             // :-) ok: 8.24
? str( n, 10, 2 )           // :-( error: 8.23
? transf( n, "###.##" )     // :-( error: 8.23
? rounding( n, 2 )          // :-) ok: 8.24
return 0
#endif

/*
I'v made a rounding routine that return the highest value (or lowest
if negative):
*/

*+
*+
*+    Function ROUNDING()
*+
*+    Called from ( rounding.prg )   2 - function t()
*+
*+
*+
function ROUNDING( nValue, nDecimals )

local nStr
local nRound := round( nValue, nDecimals )

if nDecimals >= 0   // str() doesn't works with negative
   nStr := val( str( nValue, 25, nDecimals ) )              // round via str()
   // return the highest positive or lowest negative value
   return if( nValue < 0, min( nStr, nRound ), max( nStr, nRound ) )
endif
// use standard round() if nDecimals < 0

return nRound

/*

This routine is a 100% equivallent of round() that gives the RIGHT
results.

If you find any bugs, please contact me.

e-mail: cautere@innet.be (Jos Cautereels)

*/

*+ EOF: ROUNDING.PRG
